function asccode(STRING,  chstr) {
	chstr = " !\"#$%&'()*+,-./0123456789:;<=>?"
	chstr = chstr "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"
	chstr = chstr " abcdefghijklmnopqrstuvwxyz{|}~ "
	return index(chstr,STRING)+31
}

BEGIN {
	labelcnt = 1
	linecnt = 1
}

{

# Rg폜
	gsub(/'.*/,"'")

# ϐQɂ
	gsub(/FAD/,"FD")
	gsub(/EAD/,"ED")
	gsub(/PAGE\.NO/,"PG")
	gsub(/SGD/,"SG")
	gsub(/GDR/,"GR")
	gsub(/GNO/,"GN")
	gsub(/DUMMY/,"DM")
	gsub(/BGMM/,"BM")
	gsub(/BGMN/,"BN")
	gsub(/MVA/,"VA")
	gsub(/MVE/,"VE")
	gsub(/MOB/,"OB")
	gsub(/VSB/,"SB")
	gsub(/VAR/,"AR")
	gsub(/PUX/,"UX")
	gsub(/COM\.TOP\.ADD/,"CD")
	gsub(/VSM/,"SM")
	gsub(/SELE\.P/,"SP")
	gsub(/SELE\.A/,"SA")
	gsub(/SELE\.LO/,"SL")
	gsub(/SELE\$/,"SL$")
	gsub(/POSE/,"PE")
	gsub(/SPOS/,"PS")
	gsub(/PSU/,"PU")
	gsub(/FRONT/,"FR")
	gsub(/ANS/,"AN")
	gsub(/VNO/,"VN")
	gsub(/ONO/,"OO")
	gsub(/NVA/,"NV")
	gsub(/PYY/,"PY")
	gsub(/PXX/,"PX")

# R}h̕ύXȂ
	gsub(/WRITE/,"PRINT")
	gsub(/POLL/,"VIEW")
	gsub(/COLOR */,"&9+")
	gsub(/STATUS SET */,"WINDOW #")
	gsub(/STATUS CALL */,"WINDOW ")
	gsub(/STATUS\(/,"WINDOW(")
	gsub(/CLS *3/,"CLS")
	gsub(/DEFINT *A-Z:*/,"")

# &H8000` ̏
	gsub(/&H[8-9A-F][0-9A-F][0-9A-F][0-9A-F]/,"&+65536")

# LINȄ
	while (match($0,/LINE/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/LINE/,"@@LNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,",9+",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@LNDMY@@/,"LINE")

# LOCATȄ
	while (match($0,/LOCATE */) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART+RLENGTH)
		match(ln2,/,/)
		lnx = substr(ln2,1,RSTART-1)
		ln2 = substr(ln2,RSTART+RLENGTH)
		if (match(ln2,/:/) != 0) {
			lny = substr(ln2,1,RSTART-1)
			ln2 = substr(ln2,RSTART)
		} else {
			lny = ln2
			ln2 = ""
		}
		gsub(/,.*/,"",lny)
		$0 = ln1 "ZX=" lnx ":ZY=" lny ":GOSUB 6000" ln2
	}


# RETURN sԍ̏
	gsub(/GOSUB *\*BETA\.OUT/,"&:ON RR GOTO 50,2390,20")
	gsub(/RETURN *50/,"RR=1:RETURN")
	gsub(/RETURN *\*LOAD\./,"RR=2:RETURN")
	gsub(/RETURN *\*MAIN\.LOOP/,"RR=3:RETURN")
	if ($1 == "1990") {
		gsub(/RETURN/,"RR=0:RETURN")
	}

# ʕύX
	gsub(/SWAP UP,GD/,"XX=UP:UP=GD:GD=XX")
	if ( \
		$1 ==  "860" || $1 == "1570" || $1 == "1571" || $1 == "1572" || \
		$1 == "1573" || $1 == "1574" || $1 == "1575" || $1 == "1576" || \
		$1 == "2550" || $1 == "3020" || $1 == "3050" || \
		$1 == "3070" || $1 == "3140" || $1 == "4009" || $1 == "4015" \
	) {
		$0 = $1 " REM"
	}
	if ($1 == "90") {
		gsub(/MATA/,"MA")
	}
	if ($1 == "95") {
		sub(/CALL MATA\(/,"CMD MA,4,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == "460") {
		gsub(/:CLS/,"")
	}
	if ($1 == "471") {
		$1 = 475
	}
	if ($1 == "531") {
		sub(/CALI/,"CA")
		sub(/CALL CALI\(/,"CMD CA,5,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == "745") {
		sub(/EPASS/,"EP")
		sub(/&HD743/,"\\&HD706")
		sub(/CALL EPASS\(/,"CMD EP,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ( \
		$1 == "760" || $1 == "781" || $1 == "790" || $1 == "800" || $1 == "810" || \
		$1 == "820" || $1 == "830" || $1 == "835" || $1 == "840" || $1 == "850" || \
		$1 == "870" || $1 == "880" || $1 == "890" || $1 == "900" || $1 == "901" || \
		$1 == "903" || $1 == "910" \
	) {
		sub(/GD\$/,"GD")
		match($0,/"."/)
		asc = sprintf("\\&H%02X",asccode( substr($0,RSTART+1,1) ) )
		sub(/"."/,asc)
	}
	if ($1 == "900" || $1 == "902") {
		sub(/A\$=GD\$/,"AA=GD")
		sub(/CVI\(A\$\+GD\$\)/,"AA+GD*256")
	}
	if ($1 == "932") {
		$0 = $1 " GOSUB 7000"
	}
	if ($1 == "935") {
		$0 = $1 " PRINT:ZX=1:ZY=CSRLIN:GOSUB 6000:RETURN"
	}
	if ($1 == "1050") {
		sub(/KAKKO/,"KA")
		sub(/CALL KAKKO\(/,"CMD KA,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == "1250") {
		sub(/:GD\$=.*/,"")
	}
	if ($1 == "1360") {
		sub(/ /," EXEC \\&H0123:")
	}
	if ($1 == "1390") {
		$1 = 1385
	}
	if ($1 == "1420") {
		$0 = $1 " PK=KEY(0)"
	}
	if ($1 == "1430") {
		gsub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == "1440") {
		gsub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == "1441") {
		gsub(/IF PK AND 8/,"IF PK=28")
	}
	if ($1 == "1442") {
		gsub(/IF PK AND 4/,"IF PK=29")
	}
	if ($1 == "1450") {
		$0 = $1 " IF PK=13 OR PK=32 THEN 1480"
	}
	if ($1 == "1865") {
		$0 = $0 ":FL$=\"LVP6_A\":GOSUB 9000"
	}
	if ($1 == "1867") {
		$0 = $0 ":FL$=\"LVP6_C\":GOSUB 9000"
	}
	if ($1 == "1890") {
		$0 = $1 " OPEN PA$ FOR INPUT AS#2:WINDOW #2:WINDOW GN:SET 9+UP:CLOSE #2"
	}

	if ($1 == "2110") {
		$0 = $1 " CLEAR 50,&HA000:SCREEN 1,1,1:CLS:CONSOLE 16,4,0,0:SCREEN 1,2,2"
	}
	if ($1 == "2120") {
		$0 = $1 " BLOAD \"lv.bin\":EXEC &HD386:EXEC &HD389:IF PEEK(&HDFFF)=255 THEN 8000"
	}
	if ($1 == "2130") {
		$0 = $1 " SCREEN 2,2,2:CONSOLE 0,20,0,0:CLS"
	}
	if ($1 == "2140") {
		$0 = $1 " EXEC &HD000:EXEC &HD700:EXEC &HDD00"
	}
	if ($1 == "2150") {
		$0 = $1 " IF PEEK(&HDFFF)=0 THEN GOSUB 8100 ELSE GOSUB 8200"
	}
	if ($1 == "2151") {
		$0 = $1 " POKE &HDFFD,BM:IF BM=1 THEN BLOAD \"nm4all\":EXEC &HDF00"
	}
	if ($1 == "2160") {
		$0 = $1 " SCREEN 2,2,2:CLS:ON ERROR GOTO 4000"
	}
	if ($1 == "2190") {
		sub(/CLOSE.*$/,"CLOSE")
	}
	if ($1 == "2342" || $1 == "4010") {
		$0 = $1 " GOSUB 7000"
	}
	if ($1 == "2540") {
		$0 = $1 " CLOSE #2"
	}
	if ($1 == "3000") {
		$0 = $1 " EXEC &HD380:OUT &H93,2:GD=3:GOSUB 1850:TERM:CLS:OUT &H93,3"
	}
	if ($1 == "3040") {
		$0 = $1 " TERM 0,190/2,I,490/2,I,240/2,I+95:LINE (190/2,I)-(490/2,I),9+0"
	}
	if ($1 == "3080") {
		$0 = $1 " FOR J=0 TO 23:FOR I=6 TO 0 STEP -2:Y=152+I-(J+I-6)*8"
	}
	if ($1 == "3090") {
		$0 = $1 " IF Y>=0 AND Y<159 THEN TERM 1,0,Y,319,Y+1,0,Y"
	}
	if ($1 == "3100") {
		$0 = $1 " NEXT:NEXT"
	}
	if ($1 == "3110") {
		gsub(/:WIDTH.*/,"")
	}
	if ($1 == "4100") {
		$0 = $1 " SCREEN 2,2,2:CONSOLE 0,20,0,0"
	}
	if ($1 == "5020") {
		$0 = $1 " EXEC &HDF09"
	}
	if ($1 == "5050") {
		$0 = $1 " EXEC &HDF03:EXEC &HDF06"
	}
	if ($1 == "4160") {
		gsub(/PRINT ERR;ERL/,"VIEW STR$(ERR):VIEW STR$(ERL):PRINT")
	}
	if ($1 == "4170") {
		gsub(/PRINT PG;/,"VIEW STR$(PG)")
		gsub(/PRINT/,"VIEW")
	}

# x̋LƃRgAEg
	if ( substr($2,1,1) == "*") {
		tmp1 = substr($2,2)
		$2 = "'" tmp1
		split(tmp1,tmp2,":")
		label[labelcnt] = "*" tmp2[1]
		labelnum[labelcnt] = $1
		labelcnt ++
	}


	linebuf[linecnt] = $0
	linecnt ++
}

END {
	wflag = 0
	for (i = 1;i < linecnt;) {
		for (j = 1;j < labelcnt;j ++) {
			gsub(label[j],labelnum[j],linebuf[i])
		}

# WHILE - WEND 

		match(linebuf[i+1],/[^0-9 ]/)
		n_num = substr(linebuf[i+1],1,RSTART-1)

		match(linebuf[i]  ,/[^0-9 ]/)
		c_num = substr(linebuf[i],1,RSTART-1)
		c_line = substr(linebuf[i],RSTART)

		c_if = match(c_line,/IF/)
		c_wl = match(c_line,/WHILE/)
		c_wd = match(c_line,/WEND/)

		match(c_line,/[ :]*WHILE/)
		c_b_wl = substr(c_line,1,RSTART-1)

		match(c_line,/WHILE */)
		c_x_wl = substr(c_line,RSTART+RLENGTH)
		if (match(c_x_wl,/ *:/) != 0) {
			c_x_wl = substr(c_x_wl,1,RSTART-1)
		}

		if (match(c_line,/WHILE *[^:]*:/) == 0) {
			c_e_wl = ""
		} else {
			c_e_wl = substr(c_line,RSTART+RLENGTH)
		}

		match(c_line,/WHILE *[^:]*:/)
		c_m_wl = substr(c_line,RSTART+RLENGTH)
		match(c_m_wl,/[ :]*WEND/)
		c_m_wl = substr(c_m_wl,1,RSTART-1)

		match(c_line,/[ :]*WEND[ :]*/)
		c_e_wd = substr(c_line,RSTART+RLENGTH)

		match(c_line,/[ :]*WEND/)
		c_b_wd = substr(c_line,1,RSTART-1)


		if (c_wl != 0) {
			if (c_if != 0 && c_if < c_wl) {
				print "Error!! IF before WHILE"
				print linebuf[i]
			} else {
				if (c_wd != 0) {
					if (n_num-c_num < 5) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {
						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wd == "") {
							c_e_wd = "'"
						}
						print c_num+0 " " c_b_wl
						print c_num+1 " " "IF " c_x_wl " THEN " c_num+3
						print c_num+2 " " "GOTO " c_num+4
						print c_num+3 " " c_m_wl ":GOTO " c_num+1
						print c_num+4 " " c_e_wd
					}
				} else {

					wflag = c_num+1
					if (n_num-c_num < 4) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {

						w_num = c_num

						i ++
						for (j = 1;c_wd == 0;j++) {
							wbuf[j] = linebuf[i]
							c_wd = match(wbuf[j],/WEND/)
							i ++
						}
						j --
						i --

						match(linebuf[i+1],/[^0-9 ]/)
						n_num = substr(linebuf[i+1],1,RSTART-1)

						match(linebuf[i]  ,/[^0-9 ]/)
						c_num = substr(linebuf[i],1,RSTART-1)
						c_line = substr(linebuf[i],RSTART)


						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wl == "") {
							c_e_wl = "'"
						}
						print w_num+0 " " c_b_wl
						print w_num+1 " " "IF " c_x_wl " THEN " w_num+3
						print w_num+2 " " "GOTO " c_num+1
						print w_num+3 " " c_e_wl

						for (k = 1;k < j;k ++) {
							print wbuf[k]
						}

						match(c_line,/[ :]*WEND[ :]*/)
						c_e_wd = substr(c_line,RSTART+RLENGTH)

						match(c_line,/[ :]*WEND/)
						c_b_wd = substr(c_line,1,RSTART-1)

						if (n_num-c_num < 2) {
							print "Error!! LineNumber"
							print wbuf[j]
							print wbuf[j+1]
						} else {
							if (c_e_wd == "") {
								c_e_wd = "'"
							}
							print c_num+0 " " c_b_wd ":GOTO " wflag
							print c_num+1 " " c_e_wd
							wflag = 0
						}

					}

				}
			}

		} else {
			print linebuf[i]
			if (match(linebuf[i],/^2110 /) != 0) {
				print "2115 WIDTH 40,20:CONSOLE 0,20,0,0:CLS:PRINT \"Now Loading...\""
			}
			if (match(linebuf[i],/^2190 /) != 0) {
				print "2191 BLOAD \"MSK1\":POKE &HD398,&H00:POKE &HD399,&H20:EXEC &HD383"
				print "2192 BLOAD \"MSK2\":POKE &HD398,&H20:POKE &HD399,&H20:EXEC &HD383"
				print "2193 IF PEEK(&HDFFF)=0 THEN BLOAD \"MSK3\",&HB900:BLOAD \"MSK4\",&HF000:GOTO 2197"
				print "2194 BLOAD \"MSK3\":POKE &HD398,&H40:POKE &HD399,&H17:EXEC &HD383"
				print "2195 BLOAD \"MSK4\":POKE &HD398,&H57:POKE &HD399,&H10:EXEC &HD383"
				print "2197 CLEAR 3000,&HB900:PG=0:UP=8:BM=PEEK(&HDFFD)"
			}
		}

		i ++

	}

	print "6000 POKE &HEC7C,2:POKE &HECA0,80:LOCATE ZX,ZY:POKE &HEC7C,1:POKE &HECA0,40:RETURN"
	print "7000 EXEC &H0123"
	print "7010 IF KEY(0)<>32 THEN 7010"
	print "7020 IF KEY(0)=32 THEN 7020"
	print "7030 RETURN"
	print "8000 SCREEN 1,1,1:A$=\" RAM  Ͼݡ\":GOSUB 8050"
	print "8010 A$=\"16K  64K   RAM  ¹ø޻\":GOSUB 8050"
	print "8020 GOTO 8020"
	print "8050 FOR I=1 TO LEN(A$):B=ASC(MID$(A$,I,1))"
	print "8060 IF B>=&HA6 AND B<=&HBF THEN B=B-&H20"
	print "8070 IF B>=&HC0 AND B<=&HDD THEN B=B+&H20"
	print "8080 PRINT CHR$(B);:NEXT"
	print "8090 PRINT:RETURN"
	print "8100 A$=\"RAM  16K  BGM  ׼Ͼݡ\":GOSUB 8050"
	print "8110 A$=\"HIT SPACE KEY\":GOSUB 8050"
	print "8120 GOSUB 7000:BM=0:RETURN"
	print "8200 A$=\"BGM  ׼Ͻ? (y/n)\":GOSUB 8050:EXEC &H0123"
	print "8210 KK=KEY(0)"
	print "8220 IF KK=&H79 THEN BM=1:RETURN"
	print "8230 IF KK=&H6E THEN BM=0:RETURN"
	print "8240 GOTO 8210"
	print "9000 IF PEEK(&HDFFE)=0 THEN RETURN"
	print "9010 CHAIN 1,FL$:RETURN"

}
