;
; tHg]
; gRAMpbÑ`FbN
; SD6031̃`FbN
; 摜PUT/GET
; 摜̐F̕ύX
;

	relaxed on

SENDCMD		equ	$019b
SENDDT		equ	$019e
RCVDT		equ	$01a1
DRVSTATUS	equ	$ed5a
RBANK		equ	$d70e
WBANK		equ	$d711
RBANKROM	equ	$d714
WBANKROM	equ	$d717
HOOKTERM	equ	$e791
ANA_EXP		equ	$37d9
GET_WORD	equ	$3e1b
GET_BYTE	equ	$4bf7
GET_STICK	equ	$0552
WPORT68		equ	$e6af

EXFDDF		equ	$dffe
EXRAMF		equ	$dfff

	org	$d380

	jp	SET_HOOK	; D380
	jp	TENSO		; D383
	jp	EXRAMC		; D386
	jp	EXFDDC		; D389
	jp	CHANGECOL	; D38C
	jp	FADEIN		; D38F


	org	$d398

LOADSTART:
	db	$00		; D398
LOADSIZE:
	db	$00		; D399

SCOL1:
	db	$00		; D39a
DCOL1:
	db	$00		; D39b
SCOL2:
	db	$00		; D39c
DCOL2:
	db	$00		; D39d


SET_HOOK:
	ld	hl,TERM_START
	ld	(HOOKTERM),hl
	ret

;
; tHg]
;
TENSO:

	di
	ld	hl,WPORT68
	ld	de,WPORTBUF
	ld	bc,$0004
	ldir

	ld	a,$20
	call	WBANK

	ld	hl,WPORT68
	ld	(hl),$20
	inc	hl
	ld	(hl),$22
	inc	hl
	ld	(hl),$24
	inc	hl
	ld	(hl),$26
	inc	hl

	ei

	ld	a,(LOADSTART)
	ld	d,a
	ld	e,$00
	ld	a,(LOADSIZE)
	ld	b,a
	ld	c,e

	ld	hl,$b000
	ldir

	di
	ld	hl,WPORTBUF
	ld	de,WPORT68
	ld	bc,$0004
	ldir

	call	WBANKROM
	ei

	ret

WPORTBUF:
	db	$00,$00,$00,$00


;
; gRAMpbÑ`FbN
;
; (EXRAMF):
; 0x00:16K
; 0x01:64K
; 0xFF:Ȃ
;
EXRAMC:
	call	GET_STICK
	and	$01
	ld	b,$00
	jr	nz,.end

	di

	ld	a,$20
	call	RBANK

	ld	a,$20
	call	WBANK

	ld	a,$55
	ld	($3fff),a
	ld	a,$aa
	ld	($7fff),a

	ld	a,($3fff)
	cp	$55		; 64K
	ld	b,$01
	jr	z,.end
	ld	b,$00
	cp	$aa		; 16K
	jr	z,.end
	ld	b,$ff

.end:
	ld	a,b
	ld	(EXRAMF),a

	call	RBANKROM
	call	WBANKROM

	ei
	ret


;
; SD6031̃`FbN
;
; (EXFDDF):
; 0x00:SD6031Ȃ
; 0x01:SD6031
;
EXFDDC:
	xor	a
	ld	(EXFDDF),a

	ld	a,(DRVSTATUS)
	cp	$c0			; OtQhCuAȂ
	ret	nz


		;
		; Get Memory $07EF,$07F0
		;
	ld	a,$0b
	call	SENDCMD	
	ret	c
	ld	a,$07
	call	SENDDT
	ret	c
	ld	a,$ef
	call	SENDDT
	ret	c
	ld	a,$00
	call	SENDDT
	ret	c
	ld	a,$02
	call	SENDDT
	ret	c

	call	RCVDT
	ret	c
	ld	b,a
	call	RCVDT
	ret	c
	ld	c,a

	ld	a,b
	cp	$40		; P6VW
	ret	z
	cp	$ff		; SD6031/PC-80S31ȊO
	ret	z

	ld	a,c
	cp	$ff
	ret	nz

	ld	a,$01
	ld	(EXFDDF),a
	ret


;
; OtBbNGET/PUT֘A
;
; gp@FTERM
; ݉ʂRAMɑޔ(GET)
;
; gRAM=16K̎A0x0000-0x3FFF(EXT) / 0xA000-0xCFFF / 0xF000-0xFFFF
; gRAM>16K̎A0x0000-0x6FFF(EXT) / 0xA000-0xAFFF
;
;
; gp@FTERM F,X1,Y1,X2,Y2,XX,YY
; `wŃOtBbNRs[(PUT)
;
; (X1,Y1)-(X2,Y2)  (XX,YY)- ɃRs[B
;
; F=0̎AOtBbNʂRs[B
; F=1̎AޔRAMRs[B
;
; 蔲̂߁AF=0̎Y2͖Ă
;
TERM_START:
	jp	z,GETGRAPH

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_BYTE	;  => A
	ld	(DTF),a
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_WORD	;  => HL
	ld	(DTX1),hl
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_BYTE	;  => A
	ld	(DTY1),a
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_WORD	;  => HL
	inc	hl
	ld	de,(DTX1)
	or	a
	sbc	hl,de
	ld	(DTX2),hl
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_BYTE	;  => A
	ld	d,a
	inc	d
	ld	a,(DTY1)
	ld	e,a
	ld	a,d
	sub	e
	ld	(DTY2),a
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_WORD	;  => HL
	ld	(DTXX),hl
	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_BYTE	;  => A
	ld	(DTYY),a

	ld	a,(DTF)
	or	a
	jr	nz,PUTGRAPH

	di

	xor	a
	call	RBANK
	xor	a
	call	WBANK

	xor	a
	out	($cf),a

	ld	hl,(DTX2)
	ld	de,(DTXX)
	ld	bc,(DTX1)
.mlp:
	ld	a,(DTY1)
	out	($ce),a
	ld	a,(bc)
	ex	af,af'

	ld	a,(DTYY)
	out	($ce),a
	ex	af,af'
	ld	(de),a

	inc	bc
	inc	de
	dec	hl
	ld	a,h
	or	l
	jr	nz,.mlp

	call	RBANKROM
	call	WBANKROM

	ei
	pop	hl
	ret



; OtBbN̑ޔ
; gRAM=16K̎A0x0000-0x3FFF / 0xA000-0xCFFF / 0xF000-0xFFFF
; gRAM>16K̎A0x0000-0x6FFF / 0xA000-0xAFFF
;
GETGRAPH:
	push	hl
	di

	xor	a
	call	RBANK

	ld	a,$20
	call	WBANK

	ld	de,$0000
	xor	a
	out	($cf),a
	ld	b,200		; Y

.lpy:	ld	a,200
	sub	b
	out	($ce),a
	ld	hl,$0000

.lpx:	ld	a,(hl)
	inc	hl
	and	$0f
	ld	c,a
	ld	a,(hl)
	inc	hl
	and	$0f
	rlca
	rlca
	rlca
	rlca
	or	c
	ld	(de),a
	inc	de

	ld	a,e
	or	a
	call	z,GRACAL

	ld	a,h
	cp	$01
	jr	nz,.lpx
	ld	a,l
	cp	320-256
	jr	nz,.lpx

	djnz	.lpy


	call	RBANKROM
	call	WBANKROM

	ei
	pop	hl
	ret


;
; OtBbN̋`PUT
;
PUTGRAPH:
	ld	a,(DTY2)
	ld	c,a
	ld	a,(DTYY)
	add	a,c
	ld	(DTY2),a	; YIW

	ld	hl,(DTX2)
	ex	de,hl
	ld	hl,(DTXX)
	add	hl,de
	ld	(DTX2),hl	; XIW

	ld	a,(DTY1)
	ld	l,a
	ld	e,a
	ld	h,$00
	ld	d,h
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,de		; x5
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40
	add	hl,hl		; x80
	add	hl,hl		; x160

	ld	de,(DTX1)
	srl	d
	rr	e
	add	hl,de
	ex	de,hl


	ld	a,(EXRAMF)
	or	a
	jr	nz,.exr

	ld	a,d
	cp	$40
	jr	c,.cnt
	add	a,$60
	cp	$d0
	jr	c,.cnt
	add	a,$20
	jr	.cnt

.exr:	ld	a,d
	cp	$70
	jr	c,.cnt
	add	a,$30

.cnt:	ld	d,a

	di
	ld	a,$20
	call	RBANK

	xor	a
	out	($cf),a


	ld	a,(DTYY)

.lpy:	push	af
	out	($ce),a

	ld	bc,(DTXX)
	push	de

.lpx:
	ld	a,(de)
	inc	de
	ld	l,a
	and	$0f
	ld	(bc),a
	inc	bc
	ld	a,l
	rrca
	rrca
	rrca
	rrca
	and	$0f
	ld	(bc),a
	inc	bc

	ld	a,e
	or	a
	call	z,GRACAL

	ld	hl,(DTX2)
	or	a
	sbc	hl,bc
	jr	nz,.lpx


	pop	de
	ld	hl,$00a0
	add	hl,de
	ex	de,hl
	call	z,GRACAL


	ld	a,(DTY2)
	ld	l,a
	pop	af
	inc	a
	cp	l
	jr	nz,.lpy


	call	RBANKROM
	ei
	pop	hl
	ret


;
; OtBbNޔpRAM̃AhXZo
;
GRACAL:
	ld	a,(EXRAMF)
	or	a
	jr	nz,.exr

	ld	a,d
	cp	$40
	jr	nz,.pg1
	ld	d,$a0
.pg1:	cp	$d0
	ret	nz
	ld	d,$f0
.pg2:	ret

.exr:	ld	a,d
	cp	$70
	ret	nz
	ld	d,$a0

	ret


DTF:	db	$00
DTX1:	dw	$0000
DTY1:	db	$00
DTX2:	dw	$0000
DTY2:	db	$00
DTXX:	dw	$0000
DTYY:	db	$00


;
; OtBbN̐FύX
;
CHANGECOL:
	ld	b,4
	ld	hl,SCOL1

.set:	ld	a,(hl)
	dec	a
	and	$0f
	ld	(hl),a
	inc	hl
	djnz	.set


	di
	xor	a
	call	RBANK

	xor	a
	out	($cf),a

	ld	b,0

.loop2:	ld	a,b
	out	($ce),a

	ld	hl,320

.loop1:	ld	a,(hl)
	and	$0f
	ld	c,a

	ld	a,(SCOL1)
	cp	c
	jr	nz,.no_c1

	ld	a,(DCOL1)
	jr	.str

.no_c1:	ld	a,(SCOL2)
	cp	c
	jr	nz,.no_c2

	ld	a,(DCOL2)

.str:	ld	(hl),a
.no_c2:

	dec	hl
	ld	a,l
	or	h
	jr	nz,.loop1

	inc	b
	ld	a,b
	cp	200
	jr	nz,.loop2


	call	RBANKROM
	ei
	ret

;
; ʃtF[hC
;
; 0x08:
; 0x09:
; 0x0A:
; 0x0B:}[^
; 0x0C:
; 0x0D:VA
; 0x0E:
; 0x0F:
;
FADEIN:

	di
	ld	a,$20
	call	RBANK

	ld	c,$09
	xor	a
	out	($cf),a

.loop:	ld	de,$0000
	xor	a

.lpy:	push	af
	out	($ce),a

	ld	hl,$0000
	ld	b,80

.lpx:	ld	a,(de)
	and	$0f
	cp	c
	jr	c,.np_1
	ld	a,c
.np_1:	ld	(hl),a
	inc	l
	ld	a,(de)
	rrca
	rrca
	rrca
	rrca
	and	$0f
	cp	c
	jr	c,.np_2
	ld	a,c
.np_2:	ld	(hl),a
	inc	l

	inc	e

	ld	a,(de)
	and	$0f
	cp	c
	jr	c,.np_3
	ld	a,c
.np_3:	ld	(hl),a
	inc	l
	ld	a,(de)
	rrca
	rrca
	rrca
	rrca
	and	$0f
	cp	c
	jr	c,.np_4
	ld	a,c
.np_4:	ld	(hl),a
	inc	hl

	inc	de
	ld	a,e
	or	a
	call	z,GRACAL

	djnz	.lpx

	pop	af
	inc	a
	cp	200
	jr	nz,.lpy

	inc	c
	ld	a,c
	cp	$10
	jr	nz,.loop

	call	RBANKROM
	ei

	ret




	org	$d6ff

	db	$00


end
